/*
 * Automatically generated by generate-routes.ts.
 * Do not edit this file or add other files to this directory.
 */

import type { RouteRequestBody, RouteResponse } from '@seamapi/types/connect'
import type { SetNonNullable } from 'type-fest'

import {
  getAuthHeadersForClientSessionToken,
  warnOnInsecureuserIdentifierKey,
} from 'lib/seam/connect/auth.js'
import { type Client, createClient } from 'lib/seam/connect/client.js'
import {
  isSeamHttpOptionsWithApiKey,
  isSeamHttpOptionsWithClient,
  isSeamHttpOptionsWithClientSessionToken,
  isSeamHttpOptionsWithConsoleSessionToken,
  isSeamHttpOptionsWithPersonalAccessToken,
  type SeamHttpFromPublishableKeyOptions,
  SeamHttpInvalidOptionsError,
  type SeamHttpOptions,
  type SeamHttpOptionsWithApiKey,
  type SeamHttpOptionsWithClient,
  type SeamHttpOptionsWithClientSessionToken,
  type SeamHttpOptionsWithConsoleSessionToken,
  type SeamHttpOptionsWithPersonalAccessToken,
  type SeamHttpRequestOptions,
} from 'lib/seam/connect/options.js'
import {
  limitToSeamHttpRequestOptions,
  parseOptions,
} from 'lib/seam/connect/parse-options.js'

import { SeamHttpClientSessions } from './client-sessions.js'

export class SeamHttpAcsUsers {
  client: Client
  readonly defaults: Required<SeamHttpRequestOptions>

  constructor(apiKeyOrOptions: string | SeamHttpOptions = {}) {
    const options = parseOptions(apiKeyOrOptions)
    this.client = 'client' in options ? options.client : createClient(options)
    this.defaults = limitToSeamHttpRequestOptions(options)
  }

  static fromClient(
    client: SeamHttpOptionsWithClient['client'],
    options: Omit<SeamHttpOptionsWithClient, 'client'> = {},
  ): SeamHttpAcsUsers {
    const constructorOptions = { ...options, client }
    if (!isSeamHttpOptionsWithClient(constructorOptions)) {
      throw new SeamHttpInvalidOptionsError('Missing client')
    }
    return new SeamHttpAcsUsers(constructorOptions)
  }

  static fromApiKey(
    apiKey: SeamHttpOptionsWithApiKey['apiKey'],
    options: Omit<SeamHttpOptionsWithApiKey, 'apiKey'> = {},
  ): SeamHttpAcsUsers {
    const constructorOptions = { ...options, apiKey }
    if (!isSeamHttpOptionsWithApiKey(constructorOptions)) {
      throw new SeamHttpInvalidOptionsError('Missing apiKey')
    }
    return new SeamHttpAcsUsers(constructorOptions)
  }

  static fromClientSessionToken(
    clientSessionToken: SeamHttpOptionsWithClientSessionToken['clientSessionToken'],
    options: Omit<
      SeamHttpOptionsWithClientSessionToken,
      'clientSessionToken'
    > = {},
  ): SeamHttpAcsUsers {
    const constructorOptions = { ...options, clientSessionToken }
    if (!isSeamHttpOptionsWithClientSessionToken(constructorOptions)) {
      throw new SeamHttpInvalidOptionsError('Missing clientSessionToken')
    }
    return new SeamHttpAcsUsers(constructorOptions)
  }

  static async fromPublishableKey(
    publishableKey: string,
    userIdentifierKey: string,
    options: SeamHttpFromPublishableKeyOptions = {},
  ): Promise<SeamHttpAcsUsers> {
    warnOnInsecureuserIdentifierKey(userIdentifierKey)
    const clientOptions = parseOptions({ ...options, publishableKey })
    if (isSeamHttpOptionsWithClient(clientOptions)) {
      throw new SeamHttpInvalidOptionsError(
        'The client option cannot be used with SeamHttp.fromPublishableKey',
      )
    }
    const client = createClient(clientOptions)
    const clientSessions = SeamHttpClientSessions.fromClient(client)
    const { token } = await clientSessions.getOrCreate({
      user_identifier_key: userIdentifierKey,
    })
    return SeamHttpAcsUsers.fromClientSessionToken(token, options)
  }

  static fromConsoleSessionToken(
    consoleSessionToken: SeamHttpOptionsWithConsoleSessionToken['consoleSessionToken'],
    workspaceId: SeamHttpOptionsWithConsoleSessionToken['workspaceId'],
    options: Omit<
      SeamHttpOptionsWithConsoleSessionToken,
      'consoleSessionToken' | 'workspaceId'
    > = {},
  ): SeamHttpAcsUsers {
    const constructorOptions = { ...options, consoleSessionToken, workspaceId }
    if (!isSeamHttpOptionsWithConsoleSessionToken(constructorOptions)) {
      throw new SeamHttpInvalidOptionsError(
        'Missing consoleSessionToken or workspaceId',
      )
    }
    return new SeamHttpAcsUsers(constructorOptions)
  }

  static fromPersonalAccessToken(
    personalAccessToken: SeamHttpOptionsWithPersonalAccessToken['personalAccessToken'],
    workspaceId: SeamHttpOptionsWithPersonalAccessToken['workspaceId'],
    options: Omit<
      SeamHttpOptionsWithPersonalAccessToken,
      'personalAccessToken' | 'workspaceId'
    > = {},
  ): SeamHttpAcsUsers {
    const constructorOptions = { ...options, personalAccessToken, workspaceId }
    if (!isSeamHttpOptionsWithPersonalAccessToken(constructorOptions)) {
      throw new SeamHttpInvalidOptionsError(
        'Missing personalAccessToken or workspaceId',
      )
    }
    return new SeamHttpAcsUsers(constructorOptions)
  }

  async updateClientSessionToken(
    clientSessionToken: SeamHttpOptionsWithClientSessionToken['clientSessionToken'],
  ): Promise<void> {
    const { headers } = this.client.defaults
    const authHeaders = getAuthHeadersForClientSessionToken({
      clientSessionToken,
    })
    for (const key of Object.keys(authHeaders)) {
      if (headers[key] == null) {
        throw new Error(
          'Cannot update a clientSessionToken on a client created without a clientSessionToken',
        )
      }
    }
    this.client.defaults.headers = { ...headers, ...authHeaders }
    const clientSessions = SeamHttpClientSessions.fromClient(this.client)
    await clientSessions.get()
  }

  async addToAccessGroup(body?: AcsUsersAddToAccessGroupBody): Promise<void> {
    await this.client.request<AcsUsersAddToAccessGroupResponse>({
      url: '/acs/users/add_to_access_group',
      method: 'post',
      data: body,
    })
  }

  async create(
    body?: AcsUsersCreateBody,
  ): Promise<AcsUsersCreateResponse['acs_user']> {
    const { data } = await this.client.request<AcsUsersCreateResponse>({
      url: '/acs/users/create',
      method: 'post',
      data: body,
    })

    return data.acs_user
  }

  async delete(body?: AcsUsersDeleteBody): Promise<void> {
    await this.client.request<AcsUsersDeleteResponse>({
      url: '/acs/users/delete',
      method: 'post',
      data: body,
    })
  }

  async get(
    body?: AcsUsersGetParams,
  ): Promise<AcsUsersGetResponse['acs_user']> {
    const { data } = await this.client.request<AcsUsersGetResponse>({
      url: '/acs/users/get',
      method: 'post',
      data: body,
    })

    return data.acs_user
  }

  async list(
    body?: AcsUsersListParams,
  ): Promise<AcsUsersListResponse['acs_users']> {
    const { data } = await this.client.request<AcsUsersListResponse>({
      url: '/acs/users/list',
      method: 'post',
      data: body,
    })

    return data.acs_users
  }

  async listAccessibleEntrances(
    body?: AcsUsersListAccessibleEntrancesParams,
  ): Promise<AcsUsersListAccessibleEntrancesResponse['acs_entrances']> {
    const { data } =
      await this.client.request<AcsUsersListAccessibleEntrancesResponse>({
        url: '/acs/users/list_accessible_entrances',
        method: 'post',
        data: body,
      })

    return data.acs_entrances
  }

  async removeFromAccessGroup(
    body?: AcsUsersRemoveFromAccessGroupBody,
  ): Promise<void> {
    await this.client.request<AcsUsersRemoveFromAccessGroupResponse>({
      url: '/acs/users/remove_from_access_group',
      method: 'post',
      data: body,
    })
  }

  async revokeAccessToAllEntrances(
    body?: AcsUsersRevokeAccessToAllEntrancesBody,
  ): Promise<void> {
    await this.client.request<AcsUsersRevokeAccessToAllEntrancesResponse>({
      url: '/acs/users/revoke_access_to_all_entrances',
      method: 'post',
      data: body,
    })
  }

  async suspend(body?: AcsUsersSuspendBody): Promise<void> {
    await this.client.request<AcsUsersSuspendResponse>({
      url: '/acs/users/suspend',
      method: 'post',
      data: body,
    })
  }

  async unsuspend(body?: AcsUsersUnsuspendBody): Promise<void> {
    await this.client.request<AcsUsersUnsuspendResponse>({
      url: '/acs/users/unsuspend',
      method: 'post',
      data: body,
    })
  }

  async update(body?: AcsUsersUpdateBody): Promise<void> {
    await this.client.request<AcsUsersUpdateResponse>({
      url: '/acs/users/update',
      method: 'post',
      data: body,
    })
  }
}

export type AcsUsersAddToAccessGroupBody =
  RouteRequestBody<'/acs/users/add_to_access_group'>

export type AcsUsersAddToAccessGroupResponse = SetNonNullable<
  Required<RouteResponse<'/acs/users/add_to_access_group'>>
>

export type AcsUsersAddToAccessGroupOptions = never

export type AcsUsersCreateBody = RouteRequestBody<'/acs/users/create'>

export type AcsUsersCreateResponse = SetNonNullable<
  Required<RouteResponse<'/acs/users/create'>>
>

export type AcsUsersCreateOptions = never

export type AcsUsersDeleteBody = RouteRequestBody<'/acs/users/delete'>

export type AcsUsersDeleteResponse = SetNonNullable<
  Required<RouteResponse<'/acs/users/delete'>>
>

export type AcsUsersDeleteOptions = never

export type AcsUsersGetParams = RouteRequestBody<'/acs/users/get'>

export type AcsUsersGetResponse = SetNonNullable<
  Required<RouteResponse<'/acs/users/get'>>
>

export type AcsUsersGetOptions = never

export type AcsUsersListParams = RouteRequestBody<'/acs/users/list'>

export type AcsUsersListResponse = SetNonNullable<
  Required<RouteResponse<'/acs/users/list'>>
>

export type AcsUsersListOptions = never

export type AcsUsersListAccessibleEntrancesParams =
  RouteRequestBody<'/acs/users/list_accessible_entrances'>

export type AcsUsersListAccessibleEntrancesResponse = SetNonNullable<
  Required<RouteResponse<'/acs/users/list_accessible_entrances'>>
>

export type AcsUsersListAccessibleEntrancesOptions = never

export type AcsUsersRemoveFromAccessGroupBody =
  RouteRequestBody<'/acs/users/remove_from_access_group'>

export type AcsUsersRemoveFromAccessGroupResponse = SetNonNullable<
  Required<RouteResponse<'/acs/users/remove_from_access_group'>>
>

export type AcsUsersRemoveFromAccessGroupOptions = never

export type AcsUsersRevokeAccessToAllEntrancesBody =
  RouteRequestBody<'/acs/users/revoke_access_to_all_entrances'>

export type AcsUsersRevokeAccessToAllEntrancesResponse = SetNonNullable<
  Required<RouteResponse<'/acs/users/revoke_access_to_all_entrances'>>
>

export type AcsUsersRevokeAccessToAllEntrancesOptions = never

export type AcsUsersSuspendBody = RouteRequestBody<'/acs/users/suspend'>

export type AcsUsersSuspendResponse = SetNonNullable<
  Required<RouteResponse<'/acs/users/suspend'>>
>

export type AcsUsersSuspendOptions = never

export type AcsUsersUnsuspendBody = RouteRequestBody<'/acs/users/unsuspend'>

export type AcsUsersUnsuspendResponse = SetNonNullable<
  Required<RouteResponse<'/acs/users/unsuspend'>>
>

export type AcsUsersUnsuspendOptions = never

export type AcsUsersUpdateBody = RouteRequestBody<'/acs/users/update'>

export type AcsUsersUpdateResponse = SetNonNullable<
  Required<RouteResponse<'/acs/users/update'>>
>

export type AcsUsersUpdateOptions = never
