import { z } from 'zod';
export declare const acs_system_external_type: z.ZodEnum<["pti_site", "alta_org", "salto_site", "brivo_account", "hid_credential_manager_organization", "visionline_system", "assa_abloy_credential_service"]>;
export type AcsSystemExternalType = z.infer<typeof acs_system_external_type>;
export declare const acs_system: z.ZodObject<{
    name: z.ZodString;
    workspace_id: z.ZodString;
    created_at: z.ZodString;
    acs_system_id: z.ZodString;
    external_type: z.ZodEnum<["pti_site", "alta_org", "salto_site", "brivo_account", "hid_credential_manager_organization", "visionline_system", "assa_abloy_credential_service"]>;
    external_type_display_name: z.ZodString;
    system_type: z.ZodEnum<["pti_site", "alta_org", "salto_site", "brivo_account", "hid_credential_manager_organization", "visionline_system", "assa_abloy_credential_service"]>;
    system_type_display_name: z.ZodString;
    connected_account_ids: z.ZodArray<z.ZodString, "many">;
    image_url: z.ZodString;
    image_alt_text: z.ZodString;
    can_automate_enrollment: z.ZodOptional<z.ZodBoolean>;
}, "strip", z.ZodTypeAny, {
    name: string;
    workspace_id: string;
    created_at: string;
    acs_system_id: string;
    external_type: "pti_site" | "alta_org" | "salto_site" | "brivo_account" | "hid_credential_manager_organization" | "visionline_system" | "assa_abloy_credential_service";
    external_type_display_name: string;
    system_type: "pti_site" | "alta_org" | "salto_site" | "brivo_account" | "hid_credential_manager_organization" | "visionline_system" | "assa_abloy_credential_service";
    system_type_display_name: string;
    connected_account_ids: string[];
    image_url: string;
    image_alt_text: string;
    can_automate_enrollment?: boolean | undefined;
}, {
    name: string;
    workspace_id: string;
    created_at: string;
    acs_system_id: string;
    external_type: "pti_site" | "alta_org" | "salto_site" | "brivo_account" | "hid_credential_manager_organization" | "visionline_system" | "assa_abloy_credential_service";
    external_type_display_name: string;
    system_type: "pti_site" | "alta_org" | "salto_site" | "brivo_account" | "hid_credential_manager_organization" | "visionline_system" | "assa_abloy_credential_service";
    system_type_display_name: string;
    connected_account_ids: string[];
    image_url: string;
    image_alt_text: string;
    can_automate_enrollment?: boolean | undefined;
}>;
export type AcsSystem = z.output<typeof acs_system>;
