import { z } from 'zod';
export declare const acs_user_external_type: z.ZodEnum<["pti_user", "brivo_user", "hid_credential_manager_user", "salto_site_user"]>;
export type AcsUserExternalType = z.infer<typeof acs_user_external_type>;
export declare const acs_user: z.ZodObject<{
    workspace_id: z.ZodString;
    created_at: z.ZodString;
    acs_system_id: z.ZodString;
    external_type: z.ZodOptional<z.ZodEnum<["pti_user", "brivo_user", "hid_credential_manager_user", "salto_site_user"]>>;
    external_type_display_name: z.ZodOptional<z.ZodString>;
    acs_user_id: z.ZodString;
    display_name: z.ZodString;
    is_suspended: z.ZodBoolean;
    user_identity_id: z.ZodOptional<z.ZodString>;
    hid_acs_system_id: z.ZodOptional<z.ZodString>;
    access_schedule: z.ZodOptional<z.ZodObject<{
        starts_at: z.ZodString;
        ends_at: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        starts_at: string;
        ends_at: string;
    }, {
        starts_at: string;
        ends_at: string;
    }>>;
    user_identity_email_address: z.ZodOptional<z.ZodString>;
    user_identity_phone_number: z.ZodOptional<z.ZodString>;
    full_name: z.ZodOptional<z.ZodString>;
    email: z.ZodOptional<z.ZodString>;
    email_address: z.ZodOptional<z.ZodString>;
    phone_number: z.ZodOptional<z.ZodEffects<z.ZodString, string, string>>;
}, "strip", z.ZodTypeAny, {
    workspace_id: string;
    created_at: string;
    acs_system_id: string;
    acs_user_id: string;
    display_name: string;
    is_suspended: boolean;
    external_type?: "pti_user" | "brivo_user" | "hid_credential_manager_user" | "salto_site_user" | undefined;
    external_type_display_name?: string | undefined;
    user_identity_id?: string | undefined;
    hid_acs_system_id?: string | undefined;
    access_schedule?: {
        starts_at: string;
        ends_at: string;
    } | undefined;
    user_identity_email_address?: string | undefined;
    user_identity_phone_number?: string | undefined;
    full_name?: string | undefined;
    email?: string | undefined;
    email_address?: string | undefined;
    phone_number?: string | undefined;
}, {
    workspace_id: string;
    created_at: string;
    acs_system_id: string;
    acs_user_id: string;
    display_name: string;
    is_suspended: boolean;
    external_type?: "pti_user" | "brivo_user" | "hid_credential_manager_user" | "salto_site_user" | undefined;
    external_type_display_name?: string | undefined;
    user_identity_id?: string | undefined;
    hid_acs_system_id?: string | undefined;
    access_schedule?: {
        starts_at: string;
        ends_at: string;
    } | undefined;
    user_identity_email_address?: string | undefined;
    user_identity_phone_number?: string | undefined;
    full_name?: string | undefined;
    email?: string | undefined;
    email_address?: string | undefined;
    phone_number?: string | undefined;
}>;
export type AcsUser = z.output<typeof acs_user>;
