import { z } from 'zod';
export declare const access_code_event_map: {
    access_code_created: z.ZodObject<{
        event_type: z.ZodLiteral<"access_code.created">;
        device_id: z.ZodString;
        workspace_id: z.ZodString;
        access_code_id: z.ZodString;
        connected_account_id: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        connected_account_id: string;
        workspace_id: string;
        access_code_id: string;
        device_id: string;
        event_type: "access_code.created";
    }, {
        connected_account_id: string;
        workspace_id: string;
        access_code_id: string;
        device_id: string;
        event_type: "access_code.created";
    }>;
    access_code_changed: z.ZodObject<{
        event_type: z.ZodLiteral<"access_code.changed">;
        device_id: z.ZodString;
        workspace_id: z.ZodString;
        access_code_id: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        workspace_id: string;
        access_code_id: string;
        device_id: string;
        event_type: "access_code.changed";
    }, {
        workspace_id: string;
        access_code_id: string;
        device_id: string;
        event_type: "access_code.changed";
    }>;
    access_code_scheduled_on_device: z.ZodObject<{
        event_type: z.ZodLiteral<"access_code.scheduled_on_device">;
        device_id: z.ZodString;
        connected_account_id: z.ZodString;
        workspace_id: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        connected_account_id: string;
        workspace_id: string;
        device_id: string;
        event_type: "access_code.scheduled_on_device";
    }, {
        connected_account_id: string;
        workspace_id: string;
        device_id: string;
        event_type: "access_code.scheduled_on_device";
    }>;
    backup_access_code_pulled: z.ZodObject<{
        event_type: z.ZodLiteral<"backup_access_code.pulled">;
        device_id: z.ZodString;
        workspace_id: z.ZodString;
        connected_account_id: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        connected_account_id: string;
        workspace_id: string;
        device_id: string;
        event_type: "backup_access_code.pulled";
    }, {
        connected_account_id: string;
        workspace_id: string;
        device_id: string;
        event_type: "backup_access_code.pulled";
    }>;
};
