import { z } from 'zod';
export declare const connected_account_event_map: {
    connected_account_connected: z.ZodObject<{
        event_type: z.ZodLiteral<"connected_account.connected">;
        connected_account_id: z.ZodString;
        workspace_id: z.ZodString;
        connect_webview_id: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        connect_webview_id: string;
        connected_account_id: string;
        workspace_id: string;
        event_type: "connected_account.connected";
    }, {
        connect_webview_id: string;
        connected_account_id: string;
        workspace_id: string;
        event_type: "connected_account.connected";
    }>;
    connected_account_successful_login: z.ZodObject<{
        event_type: z.ZodLiteral<"connected_account.successful_login">;
        connected_account_id: z.ZodString;
        workspace_id: z.ZodString;
        connect_webview_id: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        connect_webview_id: string;
        connected_account_id: string;
        workspace_id: string;
        event_type: "connected_account.successful_login";
    }, {
        connect_webview_id: string;
        connected_account_id: string;
        workspace_id: string;
        event_type: "connected_account.successful_login";
    }>;
    connected_account_created: z.ZodObject<{
        event_type: z.ZodLiteral<"connected_account.created">;
        connected_account_id: z.ZodString;
        workspace_id: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        connected_account_id: string;
        workspace_id: string;
        event_type: "connected_account.created";
    }, {
        connected_account_id: string;
        workspace_id: string;
        event_type: "connected_account.created";
    }>;
};
