import { z } from 'zod';
export declare const lock_event_map: {
    lock_methods: z.ZodEnum<["keycode", "manual", "unknown", "seamapi"]>;
    lock_locked: z.ZodObject<{
        event_type: z.ZodLiteral<"lock.locked">;
        device_id: z.ZodString;
        workspace_id: z.ZodString;
        lock_id: z.ZodString;
        connected_account_id: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        connected_account_id: string;
        workspace_id: string;
        device_id: string;
        lock_id: string;
        event_type: "lock.locked";
    }, {
        connected_account_id: string;
        workspace_id: string;
        device_id: string;
        lock_id: string;
        event_type: "lock.locked";
    }>;
    lock_unlocked: z.ZodObject<{
        event_type: z.ZodLiteral<"lock.unlocked">;
        device_id: z.ZodString;
        workspace_id: z.ZodString;
        lock_id: z.ZodString;
        connected_account_id: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        connected_account_id: string;
        workspace_id: string;
        device_id: string;
        lock_id: string;
        event_type: "lock.unlocked";
    }, {
        connected_account_id: string;
        workspace_id: string;
        device_id: string;
        lock_id: string;
        event_type: "lock.unlocked";
    }>;
};
