import { z } from 'zod';
export declare const manufacturer_integration_support_level: z.ZodEnum<["stable", "beta", "planned", "unsupported", "inquire"]>;
export type ManufacturerIntegrationSupportLevel = z.infer<typeof manufacturer_integration_support_level>;
export declare const manufacturer_annotation_code: z.ZodEnum<["subscription_required"]>;
export type ManufacturerAnnotationCode = z.infer<typeof manufacturer_annotation_code>;
export declare const manufacturer_annotation: z.ZodObject<{
    annotation_code: z.ZodEnum<["subscription_required"]>;
    message: z.ZodString;
}, "strip", z.ZodTypeAny, {
    message: string;
    annotation_code: "subscription_required";
}, {
    message: string;
    annotation_code: "subscription_required";
}>;
export type ManufacturerAnnotation = z.infer<typeof manufacturer_annotation>;
export declare const manufacturer: z.ZodObject<{
    manufacturer_id: z.ZodString;
    display_name: z.ZodString;
    logo: z.ZodOptional<z.ZodObject<{
        url: z.ZodString;
        width: z.ZodNumber;
        height: z.ZodNumber;
    }, "strip", z.ZodTypeAny, {
        height: number;
        width: number;
        url: string;
    }, {
        height: number;
        width: number;
        url: string;
    }>>;
    /** @deprecated */
    integration: z.ZodEnum<["stable", "beta", "planned", "unsupported", "inquire"]>;
    integration_support_level: z.ZodEnum<["stable", "beta", "planned", "unsupported", "inquire"]>;
    is_connect_webview_supported: z.ZodBoolean;
    requires_seam_support_to_add_account: z.ZodBoolean;
    device_model_count: z.ZodNumber;
    annotations: z.ZodArray<z.ZodObject<{
        annotation_code: z.ZodEnum<["subscription_required"]>;
        message: z.ZodString;
    }, "strip", z.ZodTypeAny, {
        message: string;
        annotation_code: "subscription_required";
    }, {
        message: string;
        annotation_code: "subscription_required";
    }>, "many">;
}, "strip", z.ZodTypeAny, {
    display_name: string;
    manufacturer_id: string;
    integration: "beta" | "stable" | "planned" | "unsupported" | "inquire";
    integration_support_level: "beta" | "stable" | "planned" | "unsupported" | "inquire";
    is_connect_webview_supported: boolean;
    requires_seam_support_to_add_account: boolean;
    device_model_count: number;
    annotations: {
        message: string;
        annotation_code: "subscription_required";
    }[];
    logo?: {
        height: number;
        width: number;
        url: string;
    } | undefined;
}, {
    display_name: string;
    manufacturer_id: string;
    integration: "beta" | "stable" | "planned" | "unsupported" | "inquire";
    integration_support_level: "beta" | "stable" | "planned" | "unsupported" | "inquire";
    is_connect_webview_supported: boolean;
    requires_seam_support_to_add_account: boolean;
    device_model_count: number;
    annotations: {
        message: string;
        annotation_code: "subscription_required";
    }[];
    logo?: {
        height: number;
        width: number;
        url: string;
    } | undefined;
}>;
export type Manufacturer = z.infer<typeof manufacturer>;
